/*
override RadioGroup getvalue and setvalue
*/
Ext.override(Ext.form.RadioGroup, {
  getName: function() {
    return this.items.first().getName();
  },

  getValue: function() {
    var v;

    this.items.each(function(item) {
      v = item.getRawValue();
      return !item.getValue();
    });

    return v;
  },

  setValue: function(v) {
    this.items.each(function(item) {
      item.setValue(item.getRawValue() == v);
    });
  }
});


/*
Fixed Fieldset checkboxToggle setValue, fieldset xtype: 'uxfieldset'
*/
Ext.namespace("Ext.ux.form");
Ext.ux.form.FieldSet = Ext.extend(Ext.form.FieldSet, {
    initComponent: function() {
        Ext.ux.form.FieldSet.superclass.initComponent.call(this);
        if (this.checkboxToggle && this.checkboxName) {
            this.hiddenCheckboxValue = new Ext.ux.form.FieldSetHiddenCheckboxValue({
                name: this.checkboxName
            });
            this.hiddenCheckboxValue.on('valuechange', function(field, value) {
                if (value=='0' || !value) {
                    this.collapse();
                } else {
                    this.expand();
                }
            }, this);
            this.add(this.hiddenCheckboxValue);
            delete this.checkboxName;
        }
        //Ext.ux.form.FieldSet.superclass.initComponent.call(this);
    },
    onCheckClick : function() {
        this.hiddenCheckboxValue.setValue(this.checkbox.dom.checked ? '1' : '0');
    }
});

Ext.ux.form.FieldSetHiddenCheckboxValue = Ext.extend(Ext.form.Hidden, {
    initComponent: function() {
        this.addEvents({
            'valuechange': true
        });
        Ext.ux.form.FieldSetHiddenCheckboxValue.superclass.initComponent.call(this);
    },
    setValue : function(v) {
        Ext.ux.form.FieldSetHiddenCheckboxValue.superclass.setValue.call(this, v);
        this.fireEvent('valuechange', this, v);
    }
});

Ext.reg('uxfieldset', Ext.ux.form.FieldSet);


/*
    override: send edit callback
*/
Ext.grid.CheckColumn = function(config){

    if(!this.id){
        this.id = Ext.id();
    }

    if(config.columnHeaderCheckbox)
    {
        var id = this.id + '-' + config.dataIndex;

        if( config.tip != undefined )
            config.header = '<div id="'+id+'" style="background-position:left center;" class="x-grid3-check-col">&#160;&#160;&#160;&#160;&#160;&#160;&#160;' +config.header+'&#160;&#160;&#160;<img src="'+config.tipImage+'" title="'+config.tip+'"></div>';
        else
            config.header = '<div id="'+id+'" style="background-position:left center;" class="x-grid3-check-col">&#160;&#160;&#160;&#160;&#160;&#160;&#160;' +config.header+'</div>';
    }

    Ext.apply(this, config);
    
    this.renderer = this.renderer.createDelegate(this);
};

Ext.grid.CheckColumn.prototype ={
    init : function(grid){
        this.grid = grid;
        this.grid.on('render', function(){
        var view = this.grid.getView();
        view.mainBody.on('mousedown', this.onMouseDown, this);
        }, this);

        this.grid.on('headerclick', this.onHeaderClick, this);
    },
    editabled: true,
    isCheck: false,     
    onMouseDown : function(e, t){

        if(t.id ==this.id){
            e.stopEvent();
            var v=this.grid.getView();
            var rowIndex = v.findRowIndex(t);
            var columnIndex = v.findCellIndex(t);
            var record = this.grid.store.getAt(rowIndex);
            var value= !record.data[this.dataIndex];
                
            if( this.editabled == false )
                return;

            if( value == false )
                value = 0;
            else
                value = 1;
            record.set(this.dataIndex, value);
            record.commit();
            this.grid.fireEvent('checkchange',this.grid,record,this.dataIndex,value,!value,rowIndex,rowIndex)
        }
    },
    renderer : function(v, p, record){
        p.css += ' x-grid3-check-col-td'; 
        return '<div id="'+ this.id +'" class="x-grid3-check-col'+(v?'-on':'')+'">&#160;</div>';
    },
    setEditable : function(bEditable){
        this.editabled = bEditable;
    },  
    updateHeaderCheckBoxImage: function(check){

        var id = this.id + '-' + this.dataIndex;
        
        if( check )
            document.getElementById(id).className = 'x-grid3-check-col-on';
        else
            document.getElementById(id).className = 'x-grid3-check-col';
        
    },
    getStoreIsAllChecked: function(store, dataIndex){
        var allTrue = true;
        store.each(function(record){
            if(!record.get(dataIndex))
                allTrue = false;
        });
        return allTrue;
    },
    onHeaderClick: function(headerCt, colIndex, e) {

        var me = this;      
        var columns = this.grid.initialConfig.columns;
        
        if( columns.length > colIndex ){

            if( columns[colIndex].dataIndex != me.dataIndex )
                return;
        }

        me.isCheck = !me.isCheck;

        me.updateHeaderCheckBoxImage(me.isCheck);

        this.grid.store.each(function(record){
            record.set(me.dataIndex, me.isCheck);
            record.commit();
        });
    }
};

/*
	Dynamic add or remove column
	example:
		grid.addColumn('C');
		grid.addColumn({name: 'D', defaultValue: 'D'}, {header: 'D', dataIndex: 'D'});
		grid.removeColumn('B');
*/
Ext.override(Ext.data.Store,{
	addField: function(field){
		field = new Ext.data.Field(field);
		this.recordType.prototype.fields.replace(field);
		if(typeof field.defaultValue != 'undefined'){
			this.each(function(r){
				if(typeof r.data[field.name] == 'undefined'){
					r.data[field.name] = field.defaultValue;
				}
			});
		}
	},
	removeField: function(name){
		this.recordType.prototype.fields.removeKey(name);
		this.each(function(r){
			delete r.data[name];
			if(r.modified){
				delete r.modified[name];
			}
		});
	}
});
Ext.override(Ext.grid.ColumnModel,{
	addColumn: function(column, colIndex){
		if(typeof column == 'string'){
			column = {header: column, dataIndex: column};
		}
		var config = this.config;
		this.config = [];
		if(typeof colIndex == 'number'){
			config.splice(colIndex, 0, column);
		}else{
			colIndex = config.push(column);
		}
		this.setConfig(config);
		return colIndex;
	},
	removeColumn: function(colIndex){
		var config = this.config;
		this.config = [config[colIndex]];
		config.splice(colIndex, 1);
		this.setConfig(config);
	}
});
Ext.override(Ext.grid.GridPanel,{
	addColumn: function(field, column, colIndex){
		if(!column){
			if(field.dataIndex){
				column = field;
				field = field.dataIndex;
			} else{
				column = field.name || field;
			}
		}
		this.store.addField(field);
		return this.colModel.addColumn(column, colIndex);
	},
	removeColumn: function(name, colIndex){
		this.store.removeField(name);
		if(typeof colIndex != 'number'){
			colIndex = this.colModel.findColumnIndex(name);
		}
		if(colIndex >= 0){
			this.colModel.removeColumn(colIndex);
		}
	}
});


// cross domain ajax
Ext.lib.Ajax.isCrossDomain = function(u) {
    var match = /(?:(\w*:)\/\/)?([\w\.]*(?::\d*)?)/.exec(u);
    if (!match[1]) return false; // No protocol, not cross-domain
    return (match[1] != location.protocol) || (match[2] != location.host);
};
 
Ext.override(Ext.data.Connection, {
 
    request : function(o){
        if(this.fireEvent("beforerequest", this, o) !== false){
            var p = o.params;
 
            if(typeof p == "function"){
                p = p.call(o.scope||window, o);
            }
            if(typeof p == "object"){
                p = Ext.urlEncode(p);
            }
            if(this.extraParams){
                var extras = Ext.urlEncode(this.extraParams);
                p = p ? (p + '&' + extras) : extras;
            }
 
            var url = o.url || this.url;
            if(typeof url == 'function'){
                url = url.call(o.scope||window, o);
            }
 
            if(o.form){
                var form = Ext.getDom(o.form);
                url = url || form.action;
 
                var enctype = form.getAttribute("enctype");
                if(o.isUpload || (enctype && enctype.toLowerCase() == 'multipart/form-data')){
                    return this.doFormUpload(o, p, url);
                }
                var f = Ext.lib.Ajax.serializeForm(form);
                p = p ? (p + '&' + f) : f;
            }
 
            var hs = o.headers;
            if(this.defaultHeaders){
                hs = Ext.apply(hs || {}, this.defaultHeaders);
                if(!o.headers){
                    o.headers = hs;
                }
            }

            if( o.timeout > 0 )
                this.timeout = o.timeout;
 
            var cb = {
                success: this.handleResponse,
                failure: this.handleFailure,
                scope: this,
                argument: {options: o},
                timeout : this.timeout
            };
 
            var method = o.method||this.method||(p ? "POST" : "GET");
 
            if(method == 'GET' && (this.disableCaching && o.disableCaching !== false) || o.disableCaching === true){
                url += (url.indexOf('?') != -1 ? '&' : '?') + '_dc=' + (new Date().getTime());
            }
 
            if(typeof o.autoAbort == 'boolean'){ // options gets top priority
                if(o.autoAbort){
                    this.abort();
                }
            }else if(this.autoAbort !== false){
                this.abort();
            }
            if((method == 'GET' && p) || o.xmlData || o.jsonData){
                url += (url.indexOf('?') != -1 ? '&' : '?') + p;
                p = '';
            }
            if (o.scriptTag || this.scriptTag || Ext.lib.Ajax.isCrossDomain(url)) {
               this.transId = this.scriptRequest(method, url, cb, p, o);
            } else {
               this.transId = Ext.lib.Ajax.request(method, url, cb, p, o);
            }
            return this.transId;
        }else{
            Ext.callback(o.callback, o.scope, [o, null, null]);
            return null;
        }
    },
    
    scriptRequest : function(method, url, cb, data, options) {
        var transId = ++Ext.data.ScriptTagProxy.TRANS_ID;
        var trans = {
            id : transId,
            cb : options.callbackName || "stcCallback"+transId,
            scriptId : "stcScript"+transId,
            options : options
        };
 
        url += (url.indexOf("?") != -1 ? "&" : "?") + data + String.format("&{0}={1}", options.callbackParam || this.callbackParam || 'callback', trans.cb);
 
        var conn = this;
        window[trans.cb] = function(o){
            conn.handleScriptResponse(o, trans);
        };
 
//      Set up the timeout handler
        trans.timeoutId = this.handleScriptFailure.defer(cb.timeout, this, [trans]);
 
        var script = document.createElement("script");
        script.setAttribute("src", url);
        script.setAttribute("type", "text/javascript");
        script.setAttribute("id", trans.scriptId);
        document.getElementsByTagName("head")[0].appendChild(script);
 
        return trans;
    },
 
    handleScriptResponse : function(o, trans){
        this.transId = false;
        this.destroyScriptTrans(trans, true);
        var options = trans.options;
        
//      Attempt to parse a string parameter as XML.
        var doc;
        if (typeof o == 'string') {
            if (window.ActiveXObject) {
                doc = new ActiveXObject("Microsoft.XMLDOM");
                doc.async = "false";
                doc.loadXML(o);
            } else {
                doc = new DOMParser().parseFromString(o,"text/xml");
            }
        }
 
//      Create the bogus XHR
        response = {
            responseObject: o,
            responseText: (typeof o == "object") ? Ext.util.JSON.encode(o) : String(o),
            responseXML: doc,
            argument: options.argument
        }
        this.fireEvent("requestcomplete", this, response, options);
        Ext.callback(options.success, options.scope, [response, options]);
        Ext.callback(options.callback, options.scope, [options, true, response]);
    },
    
    handleScriptFailure: function(trans) {
        this.transId = false;
        this.destroyScriptTrans(trans, false);
        var options = trans.options;
        response = {
            argument:  options.argument,
            status: 500,
            statusText: 'Server failed to respond',
            responseText: ''
        };
        this.fireEvent("requestexception", this, response, options, {
            status: -1,
            statusText: 'communication failure'
        });
        Ext.callback(options.failure, options.scope, [response, options]);
        Ext.callback(options.callback, options.scope, [options, false, response]);
    },
    
    // private
    destroyScriptTrans : function(trans, isLoaded){
        document.getElementsByTagName("head")[0].removeChild(document.getElementById(trans.scriptId));
        clearTimeout(trans.timeoutId);
        if(isLoaded){
            window[trans.cb] = undefined;
            try{
                delete window[trans.cb];
            }catch(e){}
        }else{
            // if hasn't been loaded, wait for load to remove it to prevent script error
            window[trans.cb] = function(){
                window[trans.cb] = undefined;
                try{
                    delete window[trans.cb];
                }catch(e){}
            };
        }
    }
});
